| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
Genfun::GaudiMathImplementation::GSLFunctionWithMode Class Reference

mandatory macro from CLHEP/GenericFunctions More...

`#include <GaudiMath/GSLFunAdapters.h>`

Inheritance diagram for Genfun::GaudiMathImplementation::GSLFunctionWithMode:
[legend]
Collaboration diagram for Genfun::GaudiMathImplementation::GSLFunctionWithMode:
[legend]

## Public Types
typedef double(* | Function) (double, gsl_mode_t)
| the actual type of the function More...

## Public Member Functions
| GSLFunctionWithMode (Function fun, const gsl_mode_t &mode)
| mandatory macro from CLHEP/GenericFunctions More...
| GSLFunctionWithMode (const GSLFunctionWithMode &)
| copy constructor More...
| ~GSLFunctionWithMode () override=default
| destructor More...
double | operator() (double x) const override
| the main method More...
double | operator() (const Argument &x) const override
bool | hasAnalyticDerivative () const override
unsigned int | dimensionality () const override
Genfun::Derivative | partial (unsigned int i) const override
Function | function () const
| get the function itself More...
const gsl_mode_t & | mode () const
| get the current mode More...

## Private Member Functions
| GSLFunctionWithMode ()
GSLFunctionWithMode & | operator= (const GSLFunctionWithError &)

## Private Attributes
Function | m_function
gsl_mode_t * | m_mode

## Detailed Description

mandatory macro from CLHEP/GenericFunctions

Definition at line 80 of file GSLFunAdapters.h.

## Member Typedef Documentation

typedef double(* Genfun::GaudiMathImplementation::GSLFunctionWithMode::Function) (double, gsl_mode_t)

the actual type of the function

Definition at line 84 of file GSLFunAdapters.h.

## Constructor & Destructor Documentation

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( | GSLFunctionWithMode::Function | function,
|  | const gsl_mode_t & | mode
| ) |  |

mandatory macro from CLHEP/GenericFunctions

constructor with pointer to function

Definition at line 84 of file GSLFunAdapters.cpp.

86 : AbsFunction()
87 , m_function ( function )
88 , m_mode ( new gsl_mode_t() )
89 {
90 *m_mode = mod ;
91 }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:113
Gaudi.CommonGaudiConfigurables.mod
mod
Definition: CommonGaudiConfigurables.py:22
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:112

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( | const GSLFunctionWithMode & | func | ) |

copy constructor

Definition at line 94 of file GSLFunAdapters.cpp.

95 : AbsFunction()
96 , m_function ( func.m_function )
97 , m_mode ( new gsl_mode_t () )
98 {
99 *m_mode = *(func.m_mode) ;
100 }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:113
GaudiPluginService.cpluginsvc.func
func
Definition: cpluginsvc.py:218
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:112

Genfun::GaudiMathImplementation::GSLFunctionWithMode::~GSLFunctionWithMode | ( |  | ) |
| override default

destructor

Genfun::GaudiMathImplementation::GSLFunctionWithMode::GSLFunctionWithMode | ( |  | ) |
| private

## Member Function Documentation

unsigned int Genfun::GaudiMathImplementation::GSLFunctionWithMode::dimensionality | ( |  | ) | const
| inline override

Definition at line 100 of file GSLFunAdapters.h.

100 { return 1 ; }

GSLFunctionWithMode::Function Genfun::GaudiMathImplementation::GSLFunctionWithMode::function | ( |  | ) | const

get the function itself

Definition at line 122 of file GSLFunAdapters.cpp.

123 { return m_function ; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:112

bool Genfun::GaudiMathImplementation::GSLFunctionWithMode::hasAnalyticDerivative | ( |  | ) | const
| inline override

Definition at line 99 of file GSLFunAdapters.h.

99 { return true ; }

const gsl_mode_t & Genfun::GaudiMathImplementation::GSLFunctionWithMode::mode | ( |  | ) | const

get the current mode

Definition at line 125 of file GSLFunAdapters.cpp.

126 { return *m_mode ; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:113

double Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator() | ( | double | x | ) | const
| override

the main method

Definition at line 103 of file GSLFunAdapters.cpp.

104 { return (*m_function)( x , *m_mode ) ; }
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
gsl_mode_t * m_mode
Definition: GSLFunAdapters.h:113
Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
Function m_function
Definition: GSLFunAdapters.h:112

double Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator() | ( | const Argument & | x | ) | const
| override

GSLFunctionWithMode& Genfun::GaudiMathImplementation::GSLFunctionWithMode::operator= | ( | const GSLFunctionWithError & |  | ) |
| private

Genfun::Derivative Genfun::GaudiMathImplementation::GSLFunctionWithMode::partial | ( | unsigned int | i | ) | const
| override

Definition at line 111 of file GSLFunAdapters.cpp.

112 {
113 if( i >= 1 )
114 {
115 const AbsFunction& aux = GaudiMath::Constant( 0 , 1 ) ;
116 return Genfun::FunctionNoop( &aux ) ;
117 };
118 const AbsFunction& aux = GaudiMath::Derivative( *this , i) ;
119 return Genfun::FunctionNoop( &aux ) ;
120 }
GaudiMath::Derivative
Genfun::GaudiMathImplementation::NumericalDerivative Derivative
Definition: GaudiMath.h:29
GaudiMath::Constant
Genfun::GaudiMathImplementation::Constant Constant
Definition: GaudiMath.h:27

## Member Data Documentation

Function Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_function
| private

Definition at line 112 of file GSLFunAdapters.h.

gsl_mode_t* Genfun::GaudiMathImplementation::GSLFunctionWithMode::m_mode
| private

Definition at line 113 of file GSLFunAdapters.h.

The documentation for this class was generated from the following files:

- GaudiGSL/GaudiMath/GSLFunAdapters.h
- GaudiGSL/src/Lib/GSLFunAdapters.cpp